
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using MeshVR;
using SimpleJSON;

/// <summary>
/// Body Shader 1.0.0, by Acid Bubbles
/// Concept developed by Skeet
/// Allows applying custom shaders to persons
/// </summary>
namespace HuntingSuccubus
{
public class HSEyeToolBox : MVRScript
{
    private const string DefaultShaderKey = "Keep default";


	private DAZMorph GlassHelper;
    private Atom _person;
    private DAZCharacterSelector _selector;
    private bool _dirty;
    private DAZCharacter _character;
    private Dictionary<Material, Shader> _original;
    private DAZHairGroup _hair;
    private JSONStorableStringChooser _applyToJSON;
    private JSONStorableStringChooser _shaderJSON;
    private JSONStorableFloat _alphaJSON;
    private JSONStorableFloat _renderQueue;
	DAZClothingItem item1;
	DAZClothingItem item2;
	DAZClothingItem item3;
UIDynamicToggle toggle;
        JSONStorableBool activex;
        JSONStorableString text;
JSONStorableBool enableEyeLashEyeShadow;
JSONStorableBool enableTearHighlight;
JSONStorableBool enableReflection;
JSONStorableBool enableEnhancedEyeShadow;
JSONStorableBool enableEnhancedEyeCornerShadow;
JSONStorableBool enableEnhancedEyeHighlightP;
JSONStorableBool enableEnhancedEyeHighlightS;
JSONStorableBool enableEyeBallShadow;
Texture origEyelash;
float origEyelashalpha;
float origEyelashcutoff;
float origtearSpecInt;
float origtearShininess;
float origtearFresnel;
float origrefSpecInt;
float origrefShininess; 
bool firsttime = false;



	private JSONStorableFloat _elShadowUMoveY;
	private JSONStorableFloat _elShadowUMoveZ;
	private JSONStorableFloat _elShadowLMoveY;
	private JSONStorableFloat _elShadowLMoveZ;

	private JSONStorableFloat _tearMoveY;
	private JSONStorableFloat _tearMoveZ;
	
	private JSONStorableFloat _reflectionInt;
	private JSONStorableFloat _reflectionShininess;
	private JSONStorableFloat _tearHighlightSpecInt;
	private JSONStorableFloat _tearHighlightShininess;
	private JSONStorableFloat _tearHighlightFresnel;
	private JSONStorableFloat _highlightPintensity;
	
	GenerateDAZMorphsControlUI morphControl;
	Texture myEyelash;
	Texture myEyelash2;
	
	
	
	
	
	    public void RegisterBools(){
		//SuperController.LogMessage("RegisterBools");	
		RegisterBool(enableEyeLashEyeShadow);	
		//RegisterBool(enableEnhancedEyeShadow);	
		//RegisterBool(enableEnhancedEyeCornerShadow);	
		//RegisterBool(enableEyeBallShadow);
        //RegisterBool(enableEnhancedEyeHighlightS);		
		//RegisterBool(enableEnhancedEyeHighlightP);
		//RegisterBool(enableTearHighlight);		
        //RegisterBool(enableReflection);	
		}
	
	
	
	
	
    public override void Init()
    {
			//SuperController.LogError("Init Starting");
        try
        {
            if (containingAtom?.type != "Person")
            {
                SuperController.LogError($"This plugin only works on Person atoms");
                DestroyImmediate(this);
                return;
            }
//JSONStorableFloat testjson=new JSONStorableFloat($"EyeLash Shadow Upper Move Y", 0.999f);


            _person = containingAtom;
            _selector = _person.GetComponentInChildren<DAZCharacterSelector>();
			morphControl = _selector.morphsControlUI;
			
			item1 = _selector.clothingItems.First(h => h.displayName == "HS Eyelash Shadow Toolbox");
			item2 = _selector.clothingItems.First(h => h.displayName == "Enhanced Eyes Toolbox");
			item3 = _selector.clothingItems.First(h => h.displayName == "EyeBall Shadow Toolbox");
			_selector.SetActiveClothingItem(item1, true);
			_selector.SetActiveClothingItem(item2, true);
			_selector.SetActiveClothingItem(item3, true);
			    enableEyeLashEyeShadow = new JSONStorableBool("EyeLash EyeShadow", true, (bool _) => modifyEyeLashEyeShadow());
				RegisterBool(enableEyeLashEyeShadow);
                CreateToggle(enableEyeLashEyeShadow, false);
				
				enableEnhancedEyeShadow = new JSONStorableBool("Enhanced Eyes Shadow", false, (bool _) => modifyEnhancedEyeShadow());
                RegisterBool(enableEnhancedEyeShadow);
                CreateToggle(enableEnhancedEyeShadow, false);
				
				enableEnhancedEyeCornerShadow = new JSONStorableBool("Enhanced Eyes Corner Shadow", false, (bool _) => modifyEnhancedEyeShadow());
                RegisterBool(enableEnhancedEyeCornerShadow);
                CreateToggle(enableEnhancedEyeCornerShadow, false);	
				
				enableEyeBallShadow = new JSONStorableBool("EyeBall Shadow", false, (bool _) => modifyEyeBallShadow());
                RegisterBool(enableEyeBallShadow);
                CreateToggle(enableEyeBallShadow, false);
				
				///////MOORPS/////////
				_elShadowUMoveY = new JSONStorableFloat($"EyeLash Shadow Upper Move Y", 0f, (float val) => modifyEyeLashEyeShadow(), -1f, 2f);
				RegisterFloat(_elShadowUMoveY);
				CreateSlider(_elShadowUMoveY, true);
				_elShadowUMoveZ = new JSONStorableFloat($"EyeLash Shadow Upper Move Z", 0f, (float val) => modifyEyeLashEyeShadow(), -1f, 2f);
				RegisterFloat(_elShadowUMoveZ);				
				CreateSlider(_elShadowUMoveZ, true);
				_elShadowLMoveY = new JSONStorableFloat($"EyeLash Shadow Lower Move Y", 0f, (float val) => modifyEyeLashEyeShadow(), -1f, 2f);
				RegisterFloat(_elShadowLMoveY);					
				CreateSlider(_elShadowLMoveY, true);
				_elShadowLMoveZ = new JSONStorableFloat($"EyeLash Shadow Lower Move Z", 0f, (float val) => modifyEyeLashEyeShadow(), -1f, 2f);
				RegisterFloat(_elShadowLMoveZ);					
				CreateSlider(_elShadowLMoveZ, true);
				///////MATERIALS////////
								
				enableEnhancedEyeHighlightP = new JSONStorableBool("EE Iris Highlight Primary", true, (bool _) => modifyEnhancedEyeShadow());
                RegisterBool(enableEnhancedEyeHighlightP);
                CreateToggle(enableEnhancedEyeHighlightP, false);	
				_highlightPintensity = new JSONStorableFloat($"EE Iris Highlight Primary Intensity", -0.90f, (float val) => modifyEnhancedEyeShadow(), -0.998f, -0.8f);
				RegisterFloat(_highlightPintensity);
				CreateSlider(_highlightPintensity, false);			
				enableEnhancedEyeHighlightS = new JSONStorableBool("EE Iris Highlight Secondry", false, (bool _) => modifyEnhancedEyeShadow());
                RegisterBool(enableEnhancedEyeHighlightS);
                CreateToggle(enableEnhancedEyeHighlightS, false);				
				
		
				
				enableTearHighlight = new JSONStorableBool("Tear Highlight", true, (bool _) => modifyTearHighlight());
				RegisterBool(enableTearHighlight);
                CreateToggle(enableTearHighlight,false);
				///////MOORPS/////////
				_tearMoveY = new JSONStorableFloat($"Tear Highlight Move Y", 0f, (float val) => modifyTearHighlight(), -1f, 1f);
				RegisterFloat(_tearMoveY);				
				CreateSlider(_tearMoveY, true);
				_tearMoveZ = new JSONStorableFloat($"Tear Highlight Move Z", 0f, (float val) => modifyTearHighlight(), -1f, 1f);
				RegisterFloat(_tearMoveZ);
				CreateSlider(_tearMoveZ, true);				
				///////MATERIALS////////
				_tearHighlightSpecInt = new JSONStorableFloat($"Tear Highlight Speculer", 10f, (float val) => modifyTearHighlight(), 0f, 10f);
				RegisterFloat(_tearHighlightSpecInt);					
				CreateSlider(_tearHighlightSpecInt, false);
				_tearHighlightShininess = new JSONStorableFloat($"Tear Highlight Shininess", 6f, (float val) => modifyTearHighlight(), 6f, 10f);
				RegisterFloat(_tearHighlightShininess);					
				CreateSlider(_tearHighlightShininess, false);
				_tearHighlightFresnel = new JSONStorableFloat($"Tear Highlight Fresnel", 0.5f, (float val) => modifyTearHighlight(), 0f, 1.1f);
				RegisterFloat(_tearHighlightFresnel);					
				CreateSlider(_tearHighlightFresnel, false);
				
				
				
				
				enableReflection = new JSONStorableBool("Reflection", true, (bool _) => modifyReflection());			
                RegisterBool(enableReflection);
                CreateToggle(enableReflection, false);
				_reflectionInt = new JSONStorableFloat($"Reflection Intensity", 6f, (float val) => modifyReflection(), 0f, 10f);
				RegisterFloat(_reflectionInt);
				CreateSlider(_reflectionInt, true);
				_reflectionShininess = new JSONStorableFloat($"Reflection Shininess", 8f, (float val) => modifyReflection(), 6f, 8f);
				RegisterFloat(_reflectionShininess);
				CreateSlider(_reflectionShininess, true);
				
				
				
				
				

			
			
			
			
			
			
			
			
                //mode = new JSONStorableBool("Mode", true, (bool _) => TearReflection());
                //CreateToggle(mode, false);
				
				
        }
        catch (Exception e)
        {
            SuperController.LogError("Failed to init: " + e);
            DestroyImmediate(this);
        }
					StartCoroutine(QueueTimer());
					//SuperController.LogError("Init Finished");
    }

	public void OnStart(){
		//SuperController.LogError("OnStart");
		modifyEyeLashEyeShadow();		
		modifyEnhancedEyeShadow();
		modifyEyeBallShadow();
		modifyTearHighlight();
		modifyReflection();
	}

    public void OnEnable(){
	

        try
        {
	//SuperController.LogMessage("LogError");
            _dirty = true;
 
            _character?.skin?.BroadcastMessage("OnApplicationFocus", true);
			
			StartCoroutine(QueueTimer());
	
        }
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }	

	}
	
	

    public void modifyEyeLashEyeShadow()
    {
		//SuperController.LogError("modifyEyeLashEyeShadow Starting");

		            var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
		//SuperController.LogError("modifyEyeLashEyeShadow Starting 2");
			       foreach (var wrap in allWraps)
					{
					if (wrap.ToString().Contains("HSEyelashShadowToolbox")) 
						{
						//SuperController.LogError("HSEyelashShadowToolbox found");
						foreach (var MaterialOptions in wrap.GetComponents<DAZSkinWrapMaterialOptions>())
							{
							//SuperController.LogError("MaterialOptionswrap="+wrap.ToString()+"             "+MaterialOptions.overrideId);

							var mat = wrap.GPUmaterials[2];
							//SuperController.LogMessage("mat cloth shader = "+mat.shader);
							//SuperController.LogError("....Custom Texture Loading");							
							myEyelash = mat.GetTexture("_AlphaTex");
							//SuperController.LogError("....Custom Texture Loaded");	
							mat.SetFloat("_AlphaAdjust", -1f);
							continue;
							}
						}
					}
			if (myEyelash == null)		
			StartCoroutine(QueueRescan());
					//SuperController.LogError("modifyEyeLashEyeShadow Starting 3");		
			var skin = _selector.selectedCharacter.skin;
								//SuperController.LogError("modifyEyeLashEyeShadow Starting 4");
if (skin == null)
	//SuperController.LogError("modifyEyeLashEyeShadow Starting 4.55-----returning");
			if (skin == null) return;
			Material[] mats = skin.GPUmaterials;
								//SuperController.LogError("modifyEyeLashEyeShadow Starting 5");	
			    foreach (Material mat in mats)
            {
				if (mat.name == "Eyelashes"||mat.name == "Eyelashes-1") 
			 {
				//SuperController.LogError("Eyelashes Skin found");
				if(origEyelash==null)
				{
				//SuperController.LogError("Eyelashes Original Texture Saving");
				origEyelash = mat.GetTexture("_AlphaTex");
				origEyelashalpha = mat.GetFloat("_AlphaAdjust");
				origEyelashcutoff = mat.GetFloat("_Cutoff");
				
				}
				if (myEyelash != null)
				{
				//SuperController.LogError("Eyelashes Custom Texture Loading");	
				if(enableEyeLashEyeShadow.val==true)
					{			
							//SuperController.LogError("-----------------EyelashesEyeShadow Enabling-----------------------");	
					mat.SetTexture("_AlphaTex",myEyelash);
					mat.SetFloat("_Cutoff", 0.125f);
					mat.SetColor("_Color", Color.black);
					}
				else
					{
							//SuperController.LogError("-----------------EyelashesEyeShadow Enabling-----------------------");							
					mat.SetTexture("_AlphaTex",origEyelash);
					mat.SetFloat("_AlphaAdjust", origEyelashalpha);				
					mat.SetFloat("_Cutoff", origEyelashcutoff);
					}
				}
			 }
			}
					DAZMorph EyeShadow = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOW10");
					DAZMorph HSEYELASHESSHADOWUPPER2MOVEY = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWUPPER2MOVEY");
					DAZMorph HSEYELASHESSHADOWUPPER2MOVEZ = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWUPPER2MOVEZ");
					DAZMorph HSEYELASHESSHADOWLOWER3MOVEY = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWLOWER3MOVEY");
					DAZMorph HSEYELASHESSHADOWLOWER3MOVEZ = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWLOWER3MOVEZ");					
					
					
				if(enableEyeLashEyeShadow.val==true)
				{
					EyeShadow.morphValue = 1f;					
					HSEYELASHESSHADOWUPPER2MOVEY.morphValue = _elShadowUMoveY.val;
					HSEYELASHESSHADOWUPPER2MOVEZ.morphValue = _elShadowUMoveZ.val;
					HSEYELASHESSHADOWLOWER3MOVEY.morphValue = _elShadowLMoveY.val;
					HSEYELASHESSHADOWLOWER3MOVEZ.morphValue = _elShadowLMoveZ.val;					
					
				}
				else
				{
					EyeShadow.morphValue = 0f;					
					HSEYELASHESSHADOWUPPER2MOVEY.morphValue = 0f;
					HSEYELASHESSHADOWUPPER2MOVEZ.morphValue = 0f;
					HSEYELASHESSHADOWLOWER3MOVEY.morphValue = 0f;
					HSEYELASHESSHADOWLOWER3MOVEZ.morphValue = 0f;						
				}
					
					
			       foreach (var wrap in allWraps)
					{
					  if (wrap.ToString().Contains("HSEyelashShadowToolbox")) 
						{
						//SuperController.LogMessage("HSEyelashShadowToolbox found");
						foreach (var MaterialOptions in wrap.GetComponents<DAZSkinWrapMaterialOptions>())
							{

							var mat = wrap.GPUmaterials[1];
							//SuperController.LogMessage("....Custom Texture Loading");							
							mat.SetTexture("_AlphaTex",origEyelash);
							//SuperController.LogMessage("....Custom Texture Loaded");
							if(enableEyeLashEyeShadow.val==true)
							mat.SetFloat("_AlphaAdjust", 0f);
							else
							mat.SetFloat("_AlphaAdjust", -1f);
							continue;
							}
						}
					}					
			//SuperController.LogError("modifyEyeLashEyeShadow Fininshed");	
						if(firsttime==false)
						StartCoroutine(QueueTimer());
	}

        protected IEnumerator Rescan()
        {
			//SuperController.LogError("-----------------Rescan-----------------------");
			yield return new WaitForEndOfFrame();
            modifyEyeLashEyeShadow();
        }

        private IEnumerator QueueRescan()
        {
			//SuperController.LogError("-----------------QueueRescan-----------------------");			
			int retryAttempts = 1;
            if (retryAttempts < 20000) {
                retryAttempts++;		}
             yield return Rescan();
        }
		
        private IEnumerator QueueTimer()
        {
			//SuperController.LogError("-----------------QueueRescan-----------------------");			
			int retryAttempts = 1;
            if (retryAttempts < 20000) {
                retryAttempts++;		}
             yield return Timer();
        }		
		
        protected IEnumerator Timer()
        {
			//SuperController.LogError("-----------------Rescan-----------------------");
			yield return new WaitForEndOfFrame();
			yield return new WaitForSeconds(1);
			
			firsttime=true;
            OnStart();
        }		
		
		


	
    public void modifyTearHighlight()
    {
		//SuperController.LogError("modifyTearHighlight");
            var skin = _selector.selectedCharacter.skin;
            if (skin == null) return;
			Material[] mats = skin.GPUmaterials;
			DAZMorph HSEYETEARMOVEY = morphControl.GetMorphByDisplayName("HS-EYETEARMOVEY");
			DAZMorph HSEYETEARMOVEZ = morphControl.GetMorphByDisplayName("HS-EYETEARMOVEZ");
			

			foreach (Material mat in mats) {
			if (mat.name == "Tear"||mat.name == "Tear-1") 
			{
				mat.SetFloat("_AlphaAdjust", 0.00f);
				
				if(origtearSpecInt==null)
				origtearSpecInt = mat.GetFloat("_SpecInt"); 	
				if(origtearShininess==null)
				origtearShininess = mat.GetFloat("_Shininess");
				if(origtearFresnel==null)
				origtearFresnel = mat.GetFloat("_Fresnel");
				
				if(enableTearHighlight.val==true)
			 {
				mat.SetFloat("_SpecInt", _tearHighlightSpecInt.val);
				mat.SetFloat("_Shininess", _tearHighlightShininess.val);	
				mat.SetFloat("_Fresnel", _tearHighlightFresnel.val);	
				//SuperController.LogMessage("mat.name="+);
                mat.renderQueue = 2100;
				//mat.shader = shader1;
				HSEYETEARMOVEY.morphValue = _tearMoveY.val;
				HSEYETEARMOVEZ.morphValue = _tearMoveZ.val;	
			 }
				else
			 { 
				mat.SetFloat("_SpecInt", origtearSpecInt);
				mat.SetFloat("_Shininess", origtearShininess);	
				mat.SetFloat("_Fresnel", origtearFresnel);	
				HSEYETEARMOVEY.morphValue = 0;
				HSEYETEARMOVEZ.morphValue = 0;
			 }
            }
			

			}
			
	}	

    public void modifyReflection()
    {
		//SuperController.LogError("..............................................................................modifyReflection");
		    _character = _selector.selectedCharacter;
            if (_character == null) return;
            var skin = _character.skin;
            if (skin == null) return;
			Material[] mats = skin.GPUmaterials;
			foreach (Material mat in mats) {		
				if (mat.name == "EyeReflection"||mat.name == "EyeReflection-1")
				{
				if(origrefSpecInt==null)
				origrefSpecInt = mat.GetFloat("_SpecInt"); 	
				if(origrefShininess==null)
				origrefShininess = mat.GetFloat("_Shininess");	
					
					
				if(enableReflection.val==true)	
				{
				mat.SetFloat("_AlphaAdjust", 1);
				mat.SetFloat("_SpecInt", _reflectionInt.val);
				mat.SetFloat("_Shininess", _reflectionShininess.val);
				}
				else
				{
				mat.SetFloat("_SpecInt", origrefSpecInt);
				mat.SetFloat("_Shininess", origrefShininess);					
				}
                //mat.renderQueue = 2100;
				}
			}
		
		
	}	


    public void modifyEnhancedEyeShadow()
    {
		//SuperController.LogError("modifyEnhancedEyeShadow");

		            var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);

			       foreach (var wrap in allWraps)
					{
						
					if (wrap.ToString().Contains("EnhancedEyesToolbox")) 
						{
							var mat = wrap.GPUmaterials[1];
							if(enableEnhancedEyeShadow.val==true)							
							mat.SetFloat("_AlphaAdjust", 0f);
							else mat.SetFloat("_AlphaAdjust", -1f);
							
							mat = wrap.GPUmaterials[2];
							if(enableEnhancedEyeCornerShadow.val==true)							
							mat.SetFloat("_AlphaAdjust", 0f);
							else mat.SetFloat("_AlphaAdjust", -1f);
							
							mat = wrap.GPUmaterials[4];
							//SuperController.LogMessage("Enhanced Eyes Toolbox found");
							if(enableEnhancedEyeHighlightP.val==true)
							{
							//SuperController.LogMessage("Enabled EnhancedEyeHighlightP");	
							//SuperController.LogMessage("MaterialOptionswrap="+wrap.ToString());
							mat.SetFloat("_AlphaAdjust", _highlightPintensity.val);
							}
							else mat.SetFloat("_AlphaAdjust", -1f);
						
							mat = wrap.GPUmaterials[8];
							if(enableEnhancedEyeHighlightS.val==true)							
							mat.SetFloat("_AlphaAdjust", -0.990f);
							else mat.SetFloat("_AlphaAdjust", -1f);
						}
					}
	}


    public void modifyEyeBallShadow()
    {
		//SuperController.LogError("modifyEyeBallShadow");
				var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);

			       foreach (var wrap in allWraps)
					{
						
					if (wrap.ToString().Contains("EyeBallShadowToolbox")) 
						{
							var mat = wrap.GPUmaterials[0];
						//SuperController.LogMessage("EyeBallShadowToolbox found");
							if(enableEyeBallShadow.val==true)							
							mat.SetFloat("_AlphaAdjust", 0);
							else mat.SetFloat("_AlphaAdjust", -1f);
						}
						
						
						
						
					}
		
	}





    public void Update()
    {
        try
        {



		}
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }
    }

    public void OnDisable()
    {
        try
        {
			_selector.SetActiveClothingItem(item1, false);
			_selector.SetActiveClothingItem(item2, false);
			_selector.SetActiveClothingItem(item3, false);
            _dirty = true;
 
			Material[] mats = _selector.selectedCharacter.skin.GPUmaterials; 
			foreach (Material mat in mats)
            {
				if (mat.name == "Eyelashes"||mat.name == "Eyelashes-1") 
				{
				 mat.SetTexture("_AlphaTex",origEyelash);
				 
					DAZMorph EyeShadow = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOW10");
					DAZMorph HSEYELASHESSHADOWUPPER2MOVEY = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWUPPER2MOVEY");
					DAZMorph HSEYELASHESSHADOWUPPER2MOVEZ = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWUPPER2MOVEZ");
					DAZMorph HSEYELASHESSHADOWLOWER3MOVEY = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWLOWER3MOVEY");
					DAZMorph HSEYELASHESSHADOWLOWER3MOVEZ = morphControl.GetMorphByDisplayName("HS-EYELASHESSHADOWLOWER3MOVEZ");

					EyeShadow.morphValue = 0f;					
					HSEYELASHESSHADOWUPPER2MOVEY.morphValue = 0f;
					HSEYELASHESSHADOWUPPER2MOVEZ.morphValue = 0f;
					HSEYELASHESSHADOWLOWER3MOVEY.morphValue = 0f;
					HSEYELASHESSHADOWLOWER3MOVEZ.morphValue = 0f;					 
				}
			 
				if (mat.name == "EyeReflection"||mat.name == "EyeReflection-1")
				{
				mat.SetFloat("_SpecInt", origrefSpecInt);
				mat.SetFloat("_Shininess", origrefShininess);
                //mat.renderQueue = 2100;
				}
				
				if (mat.name == "Tear"||mat.name == "Tear-1") 
				{
				mat.SetFloat("_AlphaAdjust", 0.00f);
				mat.SetFloat("_SpecInt", origtearSpecInt);
				mat.SetFloat("_Shininess", origtearShininess);	
				mat.SetFloat("_Fresnel", origtearFresnel);	
				DAZMorph HSEYETEARMOVEY = morphControl.GetMorphByDisplayName("HS-EYETEARMOVEY");
				DAZMorph HSEYETEARMOVEZ = morphControl.GetMorphByDisplayName("HS-EYETEARMOVEZ");
				HSEYETEARMOVEY.morphValue = 0;
				HSEYETEARMOVEZ.morphValue = 0;
				}

				
			}
		    var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);

			       foreach (var wrap in allWraps)
					{
						if (wrap.ToString().Contains("EnhancedEyesToolbox")) 
						{
							var matee = wrap.GPUmaterials[1];
							matee.SetFloat("_AlphaAdjust", -1f);
							
							matee = wrap.GPUmaterials[2];
							matee.SetFloat("_AlphaAdjust", -1f);
							
							matee = wrap.GPUmaterials[4];
							matee.SetFloat("_AlphaAdjust", -1f);
						
							matee = wrap.GPUmaterials[8];
							matee.SetFloat("_AlphaAdjust", -1f);
						}
					}	

 
            _character?.skin?.BroadcastMessage("OnApplicationFocus", true);
			
	
        }
        catch (Exception e)
        {
            SuperController.LogError("something failed: " + e);
        }
    }

    public void OnDestroy()
    {
        OnDisable();
    }
}
}
